#include <iostream>

struct reporter {
	int id;
	reporter(int id) : id{ id } {
		std::cout << id << " created\n";
	}

	reporter(const reporter& other) : id{ other.id + 100 } {
		std::cout << id << " copied from " << other.id << '\n';
	}

	reporter& operator=(const reporter& other) {
		int old_id = id;
		id = other.id + 10000;
		std::cout << id << " (originally " << old_id
		          << ") copy-assigned from " << other.id << '\n';
		return *this;
	}
};

struct bundle {
	reporter a, b;
};

int main() {
	reporter r1 = { 1 };
	reporter r2 = { 2 };
	std::cout << "---\n";

	reporter r3 = r1;
	reporter r4 = r2;
	std::cout << "---\n";

	r2 = r3;
	std::cout << "---\n";

	bundle b = { r3, r4 };
	std::cout << "---\n";
	bundle c = b;
	std::cout << "---\n";

	bundle d = { { 3 }, { 4 } };
	std::cout << "---\n";
	d = b;
	std::cout << "---\n";
}
