#include <array>
#include <iostream>
#include <vector>

struct noisy {
	noisy() = default;
	noisy(const noisy&) { std::cout << "copy\n"; }
	noisy(noisy&&) noexcept { std::cout << "move\n"; }
	noisy& operator=(const noisy&) {
		std::cout << "copy-assign\n";
		return *this;
	}
	noisy& operator=(noisy&&) {
		std::cout << "move-assign\n";
		return *this;
	}
	~noisy() = default;
};

struct many {
	noisy n1;
	noisy n2;
	std::array<noisy, 3> arr;
	std::vector<noisy> vec;
};

int main() {
	many m1;
	m1.vec.resize(4);
	std::cout << "---\n";
	auto m2 = m1;
	std::cout << "---\n";
	auto m3 = std::move(m1);
	std::cout << "---\n";

	many m4;
	m4 = m2;
	std::cout << "---\n";
	m4 = std::move(m3);
	std::cout << "---\n";
}
