#include <iostream>
#include <vector>
#include <map>

struct counter {
	std::map<char, int> freq;

	counter() = default;

	counter(const std::vector<char>& vec) {
		for (char c : vec) {
			++freq[c];
		}
	}

	counter(const std::map<char, int>& f)
	  : freq{ f } {}

	void print() const {
		std::cout << "{\n";
		for (auto& [key, value] : freq) {
			std::cout << "  '" << key << "': " << value << ",\n";
		}
		std::cout << "}\n";
	}

	counter& operator+=(const counter& other) {
		for (auto& [key, value] : other.freq) {
			freq[key] += value;
		}
		return *this;
	}

	friend counter operator+(counter lhs,
	                         const counter& rhs) {
		lhs += rhs;
		return lhs;
	}
};

int main() {
	counter c0;
	counter c1 = {{ 'H', 'e', 'l', 'l', 'o' }};
	counter c2 = {{ { 'x', 3 }, { 'o', 7 } }};

	c0.print();
	c1.print();
	c2.print();
}
