#include <iostream>

struct noisy {
	noisy() = default;
	noisy(const noisy&) { std::cout << "  copy\n"; }
	noisy(noisy&&) noexcept { std::cout << "  move\n"; }
};

struct immovable {
	immovable() = default;
	immovable(const immovable&) = delete;
	immovable(immovable&&) = delete;
};

noisy f_elided() {
	noisy n;
	// copy elision in current gcc/clang
	return n;
}

noisy f_temp() {
	// since C++17: "mandatory elision"
	// (delayed temporary materialisation)
	return {};
}

immovable f_imm() {
	// this works since C++17, no copy/move constructors needed
	return {};

	/* this does not work, NRVO is just an optimisation:

	immovable imm;
	return imm;

	*/
}

int main() {
	auto n1 = f_elided();
	auto n2 = f_temp();
	auto i1 = f_imm();
}
