#include <iostream>

struct noisy {
	noisy() = default;
	noisy(const noisy&) { std::cout << "  copy\n"; }
	noisy(noisy&&) noexcept { std::cout << "  move\n"; }
};

noisy f_move(bool flag) {
	noisy n1;
	noisy n2;
	// implicit move, no elision in current gcc/clang
	if (flag)
		return n1;
	return n2;
}

noisy f_copy(bool flag) {
	noisy n1;
	noisy n2;
	// no implicit move here
	return flag ? n1 : n2;
}

noisy f_move_param(noisy param) {
	return param;
}

int main() {
	std::cout << "n1\n";
	auto n1 = f_move(true);
	std::cout << "n2\n";
	auto n2 = f_move(false);

	std::cout << "n3\n";
	auto n3 = f_copy(true);
	std::cout << "n4\n";
	auto n4 = f_copy(false);

	std::cout << "n5\n";
	auto n5 = f_move_param(n1);

	std::cout << "n6\n";
	auto n6 = f_move_param({});
}
