#include <cassert>
#include <iostream>

struct maybe_int {
	bool _just = false;
	int _value = 0;

	maybe_int() {
		std::cout << "() constructor\n";
	}

	maybe_int(int v) : _just{ true }, _value{ v } {
		std::cout << "(int) constructor\n";
	}

	maybe_int& operator=(int v) {
		std::cout << "assignment operator\n";
		_just = true;
		_value = v;
		return *this;
	}

	bool has_value() const {
		return _just;
	}

	int value() const {
		assert(has_value());
		return _value;
	}
};

int main() {
	// initialisation calls the constructor
	maybe_int m1 = 1;

	maybe_int m2;

	// assignment calls the assignment operator
	m2 = 2;

	std::cout << m1.value() << ' ' << m2.value() << '\n';

	maybe_int m3 = m2;  // implicitly-defined copy constructor works

	std::cout << m3.value() << '\n';
}
