#include <vector>

// temporary materialization (mandatory copy elision since C++17)

std::vector<int> create_vector() {
	return { 1, 2, 3, 4, 5 };
}

void take_vector_by_val(std::vector<int> /* unused */) {}

int main() {
	// compare the allocation counts (try valgrind)
	auto vec = create_vector();  // one allocation, no copies

	take_vector_by_val(create_vector());  // one allocation, no copies

	std::vector orig = { 1, 2, 3, 4, 5 };  // one allocation
	auto clone = orig;  // one allocation, a copy

	take_vector_by_val(clone);  // one allocation, a copy
}
